if ('undefined' == typeof SothinkFlashDownloader) {
	SothinkFlashDownloader = {};
}
SothinkFlashDownloader.Cache = (function() {
	var clientID = "HTTP";
	var nsICache = Components.interfaces.nsICache;
	var loadTimes = 0;
	var timerID = null;
	function $() {
		return document.getElementById(arguments[0]);
	}
	return {
		testcache: function() {
			//SothinkFlashDownloader.objArray.shift();
			SothinkFlashDownloader.Cache.refreshcatchtotree();
			document.getElementById('my-tree').focus();
			if (timerID) {
				clearInterval(timerID);
			}
			timerID = setInterval(function() {
				SothinkFlashDownloader.Cache.refreshcatchtotree();
			}, 10);
			loadTimes = 0;
			$('my-tree').focus();
		},
		refreshcatchtotree: function() {
			try {
				var cs = Components.classes["@mozilla.org/network/cache-service;1"].getService(Components.interfaces.nsICacheService);
				var httpCacheSession = cs.createSession("HTTP", nsICache.STORE_ON_DISK, true);
				for (var i = SothinkFlashDownloader.objArray.length - 1; i >= 0; i--) {
					try {
						if (SothinkFlashDownloader.objArray[i].url) {
							var cdesc = httpCacheSession.openCacheEntry(SothinkFlashDownloader.objArray[i].url, nsICache.ACCESS_READ, false);
							var myfile = cdesc.file;
							outputSize = this.outputSize;

							if (myfile.exists()) {
								SothinkFlashDownloader.objArray[i]['size'] = outputSize(myfile.fileSize);
								SothinkFlashDownloader.objArray[i]['date'] = SothinkFlashDownloader.Tree.shortDateFormat(new Date(myfile.lastModifiedTime));
								SothinkFlashDownloader.objArray[i]['alive'] = true;
								cdesc.close();
							}
						}
					} catch(e) {
						// alert(e);
					}
				}
			} catch(e) {
				//alert(e);
			}

			loadTimes++;

			if (loadTimes >= 120) {
				clearInterval(timerID);
				loadTimes = 0;
				window.parent.stop();

				for (var j = SothinkFlashDownloader.objArray.length - 1; j >= 0; j--) {
					if (SothinkFlashDownloader.objArray[j]['alive'] == null) {
						SothinkFlashDownloader.objArray[j]['alive'] = false;
					}
				}
				SothinkFlashDownloader.Tree.setView();
			}
		},
		outputSize: function(filesize) {
			const kbyte = 1024;
			const kcomma = 1e3;
			const ten = 10;
			const one = 1;

			if (filesize == "?") {
				return filesize;
			} else if (filesize >= 0) {
				var temp = (Math.round(filesize / kbyte * ten)) / 10;
				if (temp <= 0.1) {
					return "0.1K";
				} else if (temp > 0.1 && temp < kcomma) {
					return temp + "K";
				} else {
					//process the most complext situation
					var part1 = Math.floor(temp);
					var part2 = Math.round(temp % one * 10);
					var result = (part2 == 0 ? "K": "." + part2 + "K");

					while (part1 > 0) {
						var part3 = part1 % kcomma;
						part1 = Math.floor(part1 / kcomma);
						if (part1 == 0) {
							result = part3 + result;
						} else {
							var parttemp = part3 >= ten * ten ? part3: (part3 >= ten ? "0" + part3: "00" + part3);
							result = "," + parttemp + result;
						}
					}
					return result;
				}
			}
		}
	}
})();