if ('undefined' == typeof SothinkFlashDownloader) {
	SothinkFlashDownloader = {};
}
SothinkFlashDownloader.Property = (function() {
	function $() {
		return document.getElementById(arguments[0]);
	}
	return {
		dosetProperty: function() {
			var fileinfor = window.opener.SothinkFlashDownloader.curSel[0],
			outputSize = this.outputSize;

			$("lblnameval").value = fileinfor.name;
			$("lblsizeval").value = (fileinfor.size == "?" ? "Unknown": fileinfor.size);
			$("lblurleval").value = fileinfor.url;
			$("lbldateval").value = (fileinfor.date == "?" ? "Unknown": fileinfor.date);
			if (fileinfor.alive) {
				$("lblcacheval").value = "Yes";
			} else {
				$("lblcacheval").value = "No";
			}

			//flash.src can not be loaded dynamicly
			if ($('embedflash')) {
				$("embedflash").src = fileinfor.url;
			}
		},
		dosavepref: function() {},
		outputSize: function(filesize) {
			const kbyte = 1024;
			const kcomma = 1e3;
			const ten = 10;
			const one = 1;

			if (filesize == "?") {
				return filesize;
			} else if (filesize >= 0) {
				var temp = (Math.round(filesize / kbyte * ten)) / 10;
				if (temp <= 0.1) {
					return "0.1K";
				} else if (temp > 0.1 && temp < kcomma) {
					return temp + "K";
				} else {
					//process the most complext situation
					var part1 = Math.floor(temp);
					var part2 = Math.round(temp % one * 10);
					var result = (part2 == 0 ? "K": "." + part2 + "K");

					while (part1 > 0) {
						var part3 = part1 % kcomma;
						part1 = Math.floor(part1 / kcomma);
						if (part1 == 0) {
							result = part3 + result;
						} else {
							var parttemp = part3 >= ten * ten ? part3: (part3 >= ten ? "0" + part3: "00" + part3);
							result = "," + parttemp + result;
						}
					}
					return result;
				}
			}
		}
	}
})();