if ('undefined' == typeof SothinkFlashDownloader) {
    SothinkFlashDownloader = {};
}
SothinkFlashDownloader.Setting = (function() {
    var defaultPath, //default save swf path
    DecPath, //Decompiler  path
    dlDecUrl, // url for downloada Dec
    dlDecName, dlDecType, MacDecUrl = "http://www.sothink.com/product/flash-decompiler-for-mac/index.htm",
    WinDecUrl = "http://www.sothink.com/product/flashdecompiler/index.htm";
    function $() {
        return document.getElementById(arguments[0]);
    }
    return {
        changeAppDir: function() {
            const nsIFilePicker = Components.interfaces.nsIFilePicker;
            var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
            fp.init(window, "", nsIFilePicker.modeGetFolder);
	    
	    var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	    localFile.initWithPath($("txtDefaultPath").value);
	    fp.displayDirectory = localFile;
	    
            var rv = fp.show();
            if (rv == nsIFilePicker.returnOK) {
                var afile = fp.file;
                return afile.path;
            } else {
                return ($("txtDefaultPath").value);
            }
        },
        opendirectorywindow: function() {
            $("txtDefaultPath").value = SothinkFlashDownloader.Setting.changeAppDir();
        },
        getDownloadFile: function(swfname, fileFilter) {
            var nsIFilePicker = Components.interfaces.nsIFilePicker;
            var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
            fp.init(window, "Save As", nsIFilePicker.modeSave);
            fp.defaultString = swfname;

            var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
            fp.displayDirectory = localFile;
            fp.appendFilter(fileFilter, "*." + fileFilter);

            var rv = fp.show();
            if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
                var file = fp.file;
                var path = fp.file.path;
                return file;
            }

            return null;
        },
        doDlInstallDec: function() {
            var decUrl = dlDecUrl;

            var file = SothinkFlashDownloader.Setting.getDownloadFile(dlDecName, dlDecType);

            var persist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);
            var ios = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
            var uri = ios.newURI(decUrl, null, null);

			if (!file) {
				return;
			}
            var target = ios.newFileURI(file);
			var xfer = Components.classes["@mozilla.org/transfer;1"].createInstance(Components.interfaces.nsITransfer);
            xfer.init(uri, target, "", null, null, null, persist, null);
            persist.progressListener = xfer;
            persist.saveURI(uri, null, null, null, null, file, null);
            window.close();

        },
        dook: function() {
            defaultPath = $("txtDefaultPath").value;
            var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.swfcatcher.");
            objectionPrefs.setCharPref("path_default", unescape(encodeURIComponent(defaultPath)));
            window.opener.defaultPath = defaultPath;
            window.close();
        },

        docancel: function() {
            window.close();
        },

        onopenwindow: function() {
            if (SothinkFlashDownloader.Overlay.IsWindowPlatform()) {
                dlDecUrl = "http://www2.sothink.com/download/swfdec.zip";
                dlDecName = "swfdec.zip";
                dlDecType = "zip";
            }

            if (SothinkFlashDownloader.Overlay.IsMacPlatform() || !SothinkFlashDownloader.Overlay.IsWindowPlatform()) {
                $("groupNoDec").setAttribute("hidden", "false");
                $("desNoDecInfo1").setAttribute("hidden", "true");
                $("desNoDecInfo2").setAttribute("hidden", "true");
                $("desNoDecInfo3").setAttribute("hidden", "true");
                $("desMacInfo1").setAttribute("hidden", "false");
		$("desMacInfo2").setAttribute("hidden", "false");
		$("desMacInfo3").setAttribute("hidden", "false");
                $("lbDecUrl").setAttribute("href", MacDecUrl);
                dlDecUrl = "http://www2.sothink.com/download/swfdec-mac.dmg";
                dlDecName = "swfdec-mac.dmg";
                dlDecType = "dmg";
            }
	    
	    var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.swfcatcher.");
            if (objectionPrefs.getCharPref("path_default") == "null" || objectionPrefs.getCharPref("path_default") == "") {
                var dirService = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
                tempDirFile = dirService.get("Desk", Components.interfaces.nsIFile);
                defaultPath = tempDirFile.path;
            } else {
		defaultPath = decodeURIComponent(escape(objectionPrefs.getCharPref("path_default")));
	    }
            //set window element state with preference arguments
            $("txtDefaultPath").value = defaultPath;
        }
    }
})();