if ('undefined' == typeof SothinkFlashDownloader) {
  SothinkFlashDownloader = {};
}
SothinkFlashDownloader.XPCU = {
  getService: function(aURL, aInterface) {
	try {
	  return Components.classes[aURL].getService(Components.interfaces[aInterface]);
	} catch(ex) {
	  alert("Error getting service: " + aURL + ", " + aInterface + "\n" + ex);
	  return null;
	}
  },

  createInstance: function(aURL, aInterface) {
	try {
	  return Components.classes[aURL].createInstance(Components.interfaces[aInterface]);

	} catch(ex) {
	  alert(" in XPCU" + ex);
	  dump("Error creating instance: " + aURL + ", " + aInterface + "\n" + ex);
	  return null;
	}
  },

  QI: function(aEl, aIName) {
	try {
	  return aEl.QueryInterface(Components.interfaces[aIName]);
	} catch(ex) {
	  throw ("Unable to QI " + aEl + " to " + aIName);
	}
  }
};