if ('undefined' == typeof SothinkFlashDownloader) {
	SothinkFlashDownloader = {};
}
SothinkFlashDownloader.defaultPath = null;
SothinkFlashDownloader.DecPath = null;

SothinkFlashDownloader.Sidebar = (function() {
	function $() {
		return document.getElementById(arguments[0]);
	}
	return {
		opensettingwindow: function() {
			window.openDialog("chrome://swfcatcher/content/setting.xul", "_new", "chrome,modal,centerscreen");
		},
		dosave: function() {
			for (var temp = SothinkFlashDownloader.objArray.length - 1; temp >= 0; temp--) {
				var urltemp = SothinkFlashDownloader.objArray[temp]['url'];
				if (urltemp.substring(0, 7) == 'http://') {
					window.parent.saveURL(urltemp, null, null, true, true, null);
				} else if (urltemp.substring(0, 7) == 'file://') {
					window.parent.saveURL(urltemp, null, null, true, true, null);
				}
			}
			window.openDialog("chrome://mozapps/content/downloads/downloads.xul", "_new", "chrome,centerscreen");
		},
		doRefresh: function() {
			SothinkFlashDownloader.Parse.doWebParse();
			if (SothinkFlashDownloader.Parse.validateURLs.length == 0) {
				alert("No Flash movie found on current Page.");
			}
		},
		doconfig: function() {
			window.openDialog("chrome://browser/content/preferences/preferences.xul", "_new", "chrome,modal,centerscreen");
		},
		setPreference: function(abranch, akey, avalue) {
			var PrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			var objectionPrefs = PrefService.getBranch(abranch);
			var type = typeof(avalue);
			try {
				if (type == "string") {
					var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
					str.data = avalue;
					objectionPrefs.setComplexValue(akey, Components.interfaces.nsISupportsString, str);
				} else if (type == "boolean") {
					objectionPrefs.setBoolPref(akey, avalue);
				} else if (type == "number") {
					objectionPrefs.setIntPref(akey, avalue);
				} else if (type == "object") {
					//objectionPrefs.setIntPref(akey, avalue);
					//do process
				}
			} catch(e) {
				alert(e);
			}
		},
		getPreference: function(abranch, akey) {
			var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(abranch);
			var result = null;
			try {
				var atype = objectionPrefs.getPrefType(akey);

				//alert([Components.interfaces.nsIPrefBranch.PREF_BOOL, Components.interfaces.nsIPrefBranch.PREF_INT, Components.interfaces.nsIPrefBranch.PREF_STRING]);
				switch (atype) {
				case Components.interfaces.nsIPrefBranch.PREF_BOOL:
					result = objectionPrefs.getBoolPref(akey);
					break;
				case Components.interfaces.nsIPrefBranch.PREF_INT:
					result = objectionPrefs.getIntPref(akey);
					break;
				case Components.interfaces.nsIPrefBranch.PREF_STRING:
					result = objectionPrefs.getComplexValue(akey, Components.interfaces.nsISupportsString).data;
					break;
				default:
					break;
				}
			} catch(e) {
				alert(e);
			}
			return result;
		},
		//the icon is clicked
		oninitialize: function() {
			//try {
			//	var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.swfcatcher.");
			//	SothinkFlashDownloader.defaultPath = objectionPrefs.getCharPref("path_default");
			//} catch(e) {
			//	SothinkFlashDownloader.defaultPath = "C:\\";
			//}

			var sizestate = SothinkFlashDownloader.Sidebar.getPreference("", "swfcatcher.treecol.size.hidden");
			var datestate = SothinkFlashDownloader.Sidebar.getPreference("", "swfcatcher.treecol.date.hidden");
			var urlstate = SothinkFlashDownloader.Sidebar.getPreference("", "swfcatcher.treecol.url.hidden");

			$('size').setAttribute('hidden', sizestate);
			$('date').setAttribute('hidden', datestate);
			$('url').setAttribute('hidden', urlstate);

			SothinkFlashDownloader.Global.hookPanelListeners();
			SothinkFlashDownloader.Tree.setView();
			SothinkFlashDownloader.Parse.doWebParse();

			if (SothinkFlashDownloader.Overlay.IsWindowPlatform() || SothinkFlashDownloader.Overlay.IsMacPlatform()) {
				$("hboxSetting").setAttribute("hidden", "false");
			} else {
				$("hboxSetting").setAttribute("hidden", "true");
			}
		},
		//the tabs are changed
		init: function() {
			//try {
			//	var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.swfcatcher.");
			//	SothinkFlashDownloader.defaultPath = objectionPrefs.getCharPref("path_default");
			//} catch(e) {
			//	SothinkFlashDownloader.defaultPath = "C:\\";
			//}

			var sizestate = SothinkFlashDownloader.Sidebar.getPreference("", "swfcatcher.treecol.size.hidden");
			var datestate = SothinkFlashDownloader.Sidebar.getPreference("", "swfcatcher.treecol.date.hidden");
			var urlstate = SothinkFlashDownloader.Sidebar.getPreference("", "swfcatcher.treecol.url.hidden");

			$('size').setAttribute('hidden', sizestate);
			$('date').setAttribute('hidden', datestate);
			$('url').setAttribute('hidden', urlstate);

			SothinkFlashDownloader.objArray = [];
			SothinkFlashDownloader.Tree.setView();
			SothinkFlashDownloader.Parse.doWebParse();

			if (SothinkFlashDownloader.Overlay.IsWindowPlatform() || SothinkFlashDownloader.Overlay.IsMacPlatform()) {
				$("hboxSetting").setAttribute("hidden", "false");
			} else {
				$("hboxSetting").setAttribute("hidden", "true");
			}
		},
		onclosewindow: function() {
			//try {
			//	var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.swfcatcher.");
			//	objectionPrefs.setCharPref("path_default", SothinkFlashDownloader.defaultPath);
			//} catch(e) {
			//	alert(e);
			//}

			//save tree column state
			var sizestate = $("size").getAttribute("hidden");
			var datestate = $("date").getAttribute("hidden");
			var urlstate = $("url").getAttribute("hidden");
			SothinkFlashDownloader.Sidebar.setPreference("", "swfcatcher.treecol.size.hidden", sizestate);
			SothinkFlashDownloader.Sidebar.setPreference("", "swfcatcher.treecol.date.hidden", datestate);
			SothinkFlashDownloader.Sidebar.setPreference("", "swfcatcher.treecol.url.hidden", urlstate);

			//unload listeners  
			SothinkFlashDownloader.Global.unhookPanelListeners();
		},
		showpopmenu: function(event) {
			SothinkFlashDownloader.Right.getCurSelection();
			if ((SothinkFlashDownloader.curSel.length <= 0) || ((SothinkFlashDownloader.curSel.length > 0) && (SothinkFlashDownloader.curSel[0].url == null))) {
				$("cmd_Saveas").setAttribute("disabled", "true");
				$("cmd_viewLocation").setAttribute("disabled", "true");
				$("cmd_Preview").setAttribute("disabled", "true");
				$("cmd_Property").setAttribute("disabled", "true");
				event.preventDefault();
				event.stopPropagation();
			} else {
				$("cmd_Saveas").setAttribute("disabled", "false");
				$("cmd_viewLocation").setAttribute("disabled", "false");
				$("cmd_Preview").setAttribute("disabled", "false");
				$("cmd_Property").setAttribute("disabled", "false");
			}
		}
	}
})();